"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.after_date = void 0;
const typescript_1 = require("typescript");
const utils_1 = require("./utils");
const getAfterDateIssue = (date, options) => {
    var _a;
    const dateParam = new Date(date).getTime() / 1000;
    const now = new Date().getTime() / 1000;
    const warningOption = (_a = options === null || options === void 0 ? void 0 : options.after_date) === null || _a === void 0 ? void 0 : _a.warn;
    if (now > dateParam) {
        return {
            error: true,
            message: "It's time to do it!",
            category: typescript_1.DiagnosticCategory.Error,
        };
    }
    if (warningOption && dateParam - now < (0, utils_1.getWarningPeriod)(warningOption)) {
        return {
            error: true,
            message: "Get ready, time is short!",
            category: typescript_1.DiagnosticCategory.Warning,
        };
    }
    return {
        error: false,
    };
};
function after_date(param, options) {
    const date = param.replace(/"|'/g, "").trim();
    if ((0, utils_1.isValidDate)(date)) {
        return getAfterDateIssue(date, options);
    }
    return {
        error: false,
    };
}
exports.after_date = after_date;
//# sourceMappingURL=after_date.js.map