"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStats = void 0;
const typescript_1 = require("typescript");
function getStats(diagnostics) {
    return diagnostics.reduce((acc, { category }) => {
        if (category === typescript_1.DiagnosticCategory.Error) {
            return {
                ...acc,
                errors: acc.errors + 1,
            };
        }
        if (category === typescript_1.DiagnosticCategory.Warning) {
            return {
                ...acc,
                warnings: acc.warnings + 1,
            };
        }
        return acc;
    }, { errors: 0, warnings: 0 });
}
exports.getStats = getStats;
//# sourceMappingURL=getStats.js.map