"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
const path = __importStar(require("path"));
const utils_1 = require("./utils");
const analyzeFile_1 = require("./analyzeFile");
function init(modules) {
    const ts = modules.typescript;
    function create({ config, languageService, project }) {
        // Diagnostic logging
        project.projectService.logger.info("WELCOME TO TODO OR DIE, BE PREPARED TO SOLVE YOUR TODO COMMENTS!");
        // Set up decorator object
        const proxy = Object.create(null);
        for (let k of Object.keys(languageService)) {
            const x = languageService[k];
            // @ts-expect-error - JS runtime trickery which is tricky to type tersely
            proxy[k] = (...args) => x.apply(languageService, args);
        }
        proxy.getSemanticDiagnostics = (filename) => {
            var _a;
            const prior = languageService.getSemanticDiagnostics(filename);
            const doc = (_a = languageService.getProgram()) === null || _a === void 0 ? void 0 : _a.getSourceFile(filename);
            const rootDir = project.getCurrentDirectory();
            const packageJson = (0, utils_1.getJsonFromFile)(`${path.normalize(rootDir)}/package.json`);
            if (!doc) {
                return prior;
            }
            const additionalKeywords = (config === null || config === void 0 ? void 0 : config.additionalKeywords) && Array.isArray(config.additionalKeywords)
                ? config.additionalKeywords.filter((keyword) => typeof keyword === "string")
                : [];
            const keywords = ["TODO", "FIXME", ...additionalKeywords];
            const context = {
                options: config === null || config === void 0 ? void 0 : config.options,
                packageJson,
                keywords,
            };
            const validations = (0, analyzeFile_1.analyzeFile)(doc.text, context);
            return [
                ...prior,
                ...validations.map(({ category, line, lineNumber, message }) => ({
                    file: doc,
                    start: doc.getPositionOfLineAndCharacter(lineNumber, 0),
                    length: line.length,
                    messageText: message,
                    category: category,
                    source: "TOD",
                    code: 666,
                })),
            ];
        };
        return proxy;
    }
    return { create };
}
module.exports = init;
//# sourceMappingURL=index.js.map