"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.on_branch = void 0;
const typescript_1 = require("typescript");
const utils_1 = require("./utils");
const getOnBranchIssue = (branchName) => {
    const currentGitBranch = (0, utils_1.getGitBranch)();
    if (branchName === currentGitBranch) {
        return {
            error: true,
            message: "It's time to do it!",
            category: typescript_1.DiagnosticCategory.Error,
        };
    }
    return {
        error: false,
    };
};
function on_branch(branchName) {
    return getOnBranchIssue(branchName.replace(/"|'/g, "").trim());
}
exports.on_branch = on_branch;
//# sourceMappingURL=on_branch.js.map