import { DiagnosticCategory } from "typescript";
export declare type Conditions = {
    after_date: (param: string, options?: ConfigOptions) => Validation;
    when: (param: string, config: WhenConfig) => Validation;
    on_branch: (param: string) => Validation;
};
export declare type ValidationError = {
    category: DiagnosticCategory;
    error: true;
    message: string;
};
export declare type ValidationApproval = {
    error: false;
};
export declare type DiagnosticError = ValidationError & {
    condition: string;
    line: string;
    lineNumber: number;
};
export declare type DiagnosticApproval = {
    error: false;
};
export declare type ConfigOptions = {
    after_date?: {
        warn?: string | boolean;
    };
    when?: {
        warn?: string | boolean;
    };
};
export declare type WhenConfig = {
    pjson?: Record<string, any> | null;
    options?: ConfigOptions["when"];
};
export declare type ValidateContext = {
    options?: ConfigOptions;
    packageJson: Record<string, unknown> | null;
    keywords: string[];
};
export declare type Diagnostic = DiagnosticError | DiagnosticApproval;
export declare type Validation = ValidationError | ValidationApproval;
export declare type Periods = {
    w: number;
    d: number;
    h: number;
};
export declare type ValidateTodo = {
    additionalKeywords?: string[];
    options?: ConfigOptions;
    todo: string;
};
export declare type Levels = {
    M: number;
    m: number;
    p: number;
};
