import { Periods } from "./types";
export declare const isValidDate: (date: string) => boolean;
export declare const isValidWarnOption: (option: string) => string | boolean;
export declare const isValidWarnWhenOption: (option: string) => boolean;
export declare const parseOption: (option: string) => [number, string];
export declare const parseWarnOption: (option: string) => [number, keyof Periods];
export declare const parseWarnWhenOption: (option: string) => [number, number];
export declare const getWarningPeriod: (warnOption: string | true) => number;
export declare const startsWithKeyword: (todo: string, keywords: string[]) => boolean;
export declare const getWarningWhen: (warnOption: string | true) => [number, number];
export declare const getSplitPackageVersion: (version: string) => number[];
export declare const getJsonFromFile: (filepath: string) => Record<string, any> | null;
export declare const pipe: <T extends any[]>(fn: (...args: T) => any, ...fns: ((a: any) => any)[]) => (...args: T) => any;
export declare const getGitBranch: () => string | undefined;
